\chapter{MiMiC Application Programming Interface - MMCAPI}
\label{Ch:MMCAPI}


\section{Working Modalities of MMCAPI: Link vs Copy Mode}
MiMiC can work in two modalities, in the i) \emph{link} and ii) \emph{copy} modality. In the link 
modality MiMiC data structures point to the data structures of the host code, presently to CPMD. 
At the moment, we envisage linking to positions, forces, electron density and external field, etc. 
Links to these data structures is established during the initialization (is it worth to allow 
\emph{re-linking}?). Following the linking, any MiMiC \emph{read/write} access does not require any 
explicit passage of data by interface.

This operation mode has the advantage of simplifying the MMCAPI. The link modality has also the 
advantage of reducing the number of copies, for maximizing the performance. However, it also has 
some potential drawbacks. For example, it makes obscure the in/out data flow between the host 
program and MiMiC. A second drawback is that it enforce the host program to have data structures 
consistent with the MiMiC model. To remove these limitations we introduced the copy modality. 
In the copy modality MiMiC instantiate internal data structures for   positions, forces, electron density 
and external field, etc, and then link them (analogous to the link mode, but the linking is toward 
internal data structures). The interaction with the host code takes place through a copy of the its data 
into the MiMiC internal data structures. This make MiMiC perhaps less efficient (how much must be 
measured) but certainly more flexible. One could envision an interface for the copy (both, in and our, 
\emph{push} and \emph{pull}) \emph{via} a user-defined write/read function. This would make MiMiC 
extendable to any host code, as it is the host code which has to provide two functions to copy 
to/from its data structures. 

\section{API procedures}
MiMiC has to be provide the following API procedures.
\begin{itemize}
\item mimic\_initialization
\item mimic\_finalization
\item mimic\_compute\_potential
\item mimic\_compute\_energy
\item mmc\_compute\_forces
\item mmc\_force\_driver ! computes potential, energy and forces
\end{itemize}